module fpga_load_gen(

input wire iCLK,
input wire iRST_n,
input wire start,
input	wire image_id_in,

output reg fpga_load_request,
output wire fpga_load_clk,
output reg fpga_load_image_id,
output wire load_request,
input  wire	max_sel
);

reg [3:0] load_req_cnt;




edge_detector u1(

.iCLK(iCLK),
.iRST_n(iRST_n),
.iIn(start),
.oFallING_EDGE(load_request),
.oRISING_EDGE(),
.oDEBOUNCE_OUT(),
);

reg out_en;

//parameter load_cnt_max = 11;

wire [3:0] load_cnt_max = max_sel ? 12 : 5;

always@(posedge iCLK or negedge iRST_n)
	begin
		if (!iRST_n)
			 begin
				load_req_cnt <= 0;
				fpga_load_request <= 1'b1;
				out_en <= 1'b0;
				fpga_load_image_id <= 1'b1;
			 end
		else if (load_request)	
			begin 
				load_req_cnt <= load_req_cnt + 1;
			end
		else if ((load_req_cnt > 0) &&(load_req_cnt < load_cnt_max+1))
			begin 
				load_req_cnt <= load_req_cnt + 1;
				fpga_load_request <= 1'b0;	
				out_en <= 1'b1;
				fpga_load_image_id <= image_id_in;
			end
		else 
			 begin
				load_req_cnt <= 0;
				fpga_load_request <= 1'b1;
				out_en <= 1'b0;
				fpga_load_image_id <= 1'b1;
			 end		
	end


assign fpga_load_clk = out_en ?  iCLK : 1'b1;
	
endmodule 
	
	
	